<?php

namespace Drupal\ggl_map_examples\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\ggl_map_examples\GglMapExamplesHelper;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * @Block(
 *  id = "single_map_block",
 *  admin_label = @Translation("Single collection map"),
 * )
 */
class SingleMap extends BlockBase implements ContainerFactoryPluginInterface {

  /**
   * @var GglMapExamplesHelper|object|null
   */
  private GglMapExamplesHelper $gglMapExamplesHelper;

  public function __construct(array $configuration, $plugin_id, $plugin_definition, GglMapExamplesHelper $gglMapExamplesHelper) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->gglMapExamplesHelper = $gglMapExamplesHelper;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static(
      $configuration, $plugin_id, $plugin_definition,
      $container->get('ggl_map_examples.ggl_map_examples_helper')
    );
  }


  /**
   * {@inheritdoc}
   */
  public function build() {
    return [
      '#theme' => 'single_map',
      '#ggl_map' => [
        "#theme" => "ggl_map",
        '#collection' => [
          [
            'id' => 'single_map',
            'url' => $this->gglMapExamplesHelper->modulePath().'/data/single_collection.json',
          ],
        ],
      ],
      '#modulePath' => $this->gglMapExamplesHelper->modulePath(),
      '#attached' => [
        'library' => [
          'ggl_map_examples/map',
        ],
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheMaxAge() {
    return 0;
  }

}
